#include "stock.h"
#include <string.h>

/* sync requests don't send request type 
 * async requests have to send a request type while sending 
 */

/* differential updating is yet to be added, much desired feature... */

void send_company_info (int client);

/* sync ::::: check if short ints work fine... */
static void send_comp_misc (int client) {
   sw_cid (max_companies);
   sw_s_int (client, max_simult_quot);
   sw_s_int (client, max_history);
   return;
}

/* sync */
static void send_comp_last_trade (int client, cid_t c1, cid_t c2) {
   register int i;

   if ((c1 > c2) || (c2 > max_companies)) {
      SEND_ERR;
      return;
   } else SEND_OK;

   ++c2; 

   for (i=c1; i<c2; ++i)      
     sw_pr (company[i].trade_history[company[i].last_trade]);
   return;
}
   
/* sync */
static void send_comp_hist (int client, cid_t c1, cid_t c2) {
   register int i,j;
   
   if ((c1 > c2) || (c2 > max_companies)) {
      SEND_ERR;
      return;
   } else SEND_OK;

   ++c2; 

   for (i=c1; i<c2; ++i) {      
      company_t *c = &company[i];
      
      for (j=0; j<max_history; ++j) 	 
	 sw_pr (c->trade_history[j]);
   }
   return;
}

static void send_comp_name (int client, cid_t c1, cid_t c2) {
   register int i;
   
   if ((c1 > c2) || (c2 > max_companies)) {
      SEND_ERR;
      return;
   } else SEND_OK;

   ++c2; 

   for (i=c1; i<c2; ++i) {      
      company_t *c = &company[i];
      
/*      sw_s_int (client, strlen(c->name) + 1); */
      sock_write (client, c->name, strlen(c->name) + 1);
/*      sock_write (client, c->index, strlen(c->index) + 1);  */
   }
   return;
}

static void send_comp_buy_list (int client, cid_t c1, cid_t c2) {
      register int i,j;
   
   if ((c1 > c2) || (c2 > max_companies)) {
      SEND_ERR;
      return;
   } else SEND_OK;

   ++c2; 

   for (i=c1; i<c2; ++i) {
      company_t *c = &company[i];

      for (j=0; j<max_simult_quot; ++j) {
	 stock_company_t *s = c->buy[j];
      
	 sw_pr (s->pr);
	 sw_qty (s->qty);
      }
   }
   return;
}

static void send_comp_sell_list (int client, cid_t c1, cid_t c2) {
      register int i,j;
   
   if ((c1 > c2) || (c2 > max_companies)) {
      SEND_ERR;
      return;
   } else SEND_OK;

   ++c2; 

   for (i=c1; i<c2; ++i) {
      company_t *c = &company[i];

      for (j=0; j<max_simult_quot; ++j) {
	 stock_company_t *s = c->sell[j];
      
	 sw_pr (s->pr);
	 sw_qty (s->qty);
      }
   }
   return;
}

void send_company_info (int client) {
   req_t req;
   cid_t cid1, cid2;
   
   sr_req (req);
   
   switch (req) {
   
    case COMP_MISC:
      send_comp_misc (client);
      SEND_OK;
      break;
	 
    case COMP_LAST_TRADE_1:
      sr_cid (cid1);
      send_comp_last_trade (client, cid1, cid1);
      SEND_OK;
      break;
	 
    case COMP_LAST_TRADE:
      sr_cid (cid1);
      sr_cid (cid2);
      send_comp_last_trade (client, cid1, cid2);
      SEND_OK;
      break;

    case COMP_HIST_1:
      sr_cid (cid1);
      send_comp_hist (client, cid1, cid1);
      SEND_OK;
      break;
      
    case COMP_HIST:
      sr_cid (cid1);
      sr_cid (cid2);
      send_comp_hist (client, cid1, cid2);
      SEND_OK;
      break;
      
    case COMP_BUY_LIST_1:
      sr_cid (cid1);
      send_comp_buy_list (client, cid1, cid1);
      SEND_OK;
      break;
      
    case COMP_BUY_LIST:
      sr_cid (cid1);
      sr_cid (cid2);
      send_comp_buy_list (client, cid1, cid2);
      SEND_OK;
      break;
      
    case COMP_SELL_LIST_1:
      sr_cid (cid1);
      send_comp_sell_list (client, cid1, cid1);
      SEND_OK;
      break;
      
    case COMP_SELL_LIST:
      sr_cid (cid1);
      sr_cid (cid2);
      send_comp_sell_list (client, cid1, cid2);
      SEND_OK;
      break;
      
    case COMP_NAME_1:
      sr_cid (cid1);
      send_comp_name (client, cid1, cid1);
      SEND_OK;
      break;
      
    case COMP_NAME:
      sr_cid (cid1);
      sr_cid (cid2);
      send_comp_name (client, cid1, cid2);
      SEND_OK;
      break;
      
    default:
#ifdef DEBUG
      printf ("Bullshit request, send_company_info\n");
#endif
      kick_player ();
      break;
   }
   return;
}

