#ifndef SOCKET_H

#define SOCKET_H

#include <netinet/in.h>
#include "stock.h"

req_t ok, err;

/* socket.h has macros for sock_read_int and friends and function
 * declararions for socket.c 
 */

#define sw(socket, buf, cnt) sock_write (socket, buf, cnt)

#define sr(socket, buf, cnt) sock_read (socket, buf, cnt)

#define sr_int(socket, a)     sock_read (socket, & ## a, sizeof(int32_t)); \
                              a = ntohl(a)

#define sr_s_int(socket, a)   sock_read (socket, & ## a, sizeof(int16_t)); \
                              a = ntohs(a)

#define sr_char(socket, a)    sock_read (socket, & ## a, sizeof(char))

#define sw_char(socket, a)    sock_write (socket, & ## a, sizeof(char))

#define SEND_OK               sw_char (client, ok)
#define SEND_ERR              sw_char (client, err)

/* #define RECV_OK sr_char (client, ok); */

/* We have to use htonl() and ntohl() and friends cause the
 * byte ordering is the other way round on i80x86 and probably some 
 * others too... can't help the extra clocks, cause the CPUs are 
 * quite cheap :) 
 */

#define sr_plid(plid)     sr_int (client, plid)
#define sw_plid(plid)     sw_int (client, plid)

#define sr_qty(qty)       sr_int (client, qty); if (qty <= 0) kick_player ();
#define sw_qty(qty)       sw_int (client, qty)

#define sr_pr(pr)         sr_int (client, pr); if (pr <= 0) kick_player ();
#define sw_pr(pr)         sw_int (client, pr)

#define CHK_CID(cid)      if ((cid < 0) || (cid > max_companies)) { \
                                                             kick_player (); }

#define sr_cid(cid)       sr_int (client, cid); CHK_CID(cid);
#define sw_cid(cid)       sw_int (client, cid)

#define sr_req(req)       sr_char (client, req)
#define sw_req(req)       sw_char (client, req)

#define sr_passwd(passwd) sr_int (client, passwd)
#define sw_passwd(passwd) sw_int (client, passwd)

#endif /* SOCKET_H */
